/* 
 * Zach Mintzer
 * CPE471 Final Project
 */

#pragma once
#ifndef _TEXTUREPLANE_H_
#define _TEXTUREPLANE_H_

#ifdef __APPLE__
#include <GLUT/glut.h>
#endif
#ifdef __unix__
#include <GL/glut.h>
#endif
#include "tiny_obj_loader.h"
#include "MatrixStack.h"
#include "Image.h"
#include "GLSL.h"

class TexturePlane
{
public:
	TexturePlane();
	virtual ~TexturePlane();
	void load(std::vector<float> posBuf, std::vector<float> texBuf, 
    std::vector<unsigned int> indBuf, glm::mat4 mat, glm::mat3 T);
	void init();
   void texInit(int id, const char *filename, int clamp);
	void draw(MatrixStack *MV, MatrixStack *P, GLint h_MV, GLint h_P, GLint h_T,
    GLuint pid, GLint h_vertPos, GLint h_vertTexCoords, GLint h_texture);
	
private:
	std::vector<float> positionBuf;
   std::vector<float> texCoordsBuf;
   std::vector<unsigned int> indexBuf;
	GLuint posBufID;
	GLuint texBufID;
	GLuint indBufID;
   GLuint textureID;
   int tex_id;
   glm::mat4 TransformationMat;
   glm::mat3 TextureTransform;
};

#endif
