//
// sueda
// October, 2014
//

#pragma once
#ifndef _TEXTURESHAPE_H_
#define _TEXTURESHAPE_H_

#ifdef __APPLE__
#include <GLUT/glut.h>
#endif
#ifdef __unix__
#include <GL/glut.h>
#endif
#include "tiny_obj_loader.h"
#include "MatrixStack.h"
#include "Image.h"
#include "GLSL.h"

class TextureShape
{
public:
   TextureShape();
   virtual ~TextureShape();
   void setAutoScale(bool a) { autoScale = a; };
   void load(const std::string &meshName);
   void init();
   void texInit(int id, const char *filename, int clamp);
   void draw(GLint h_vertPos, GLint h_vertNor, GLint h_vertTexCoords, 
    GLint h_texture);
   
private:
   bool autoScale;
   std::vector<tinyobj::shape_t> shapes;
   GLuint posBufID;
   GLuint norBufID;
   GLuint texBufID;
   GLuint indBufID;
   GLuint posBufObj;
   GLuint norBufObj;
   GLuint texBufObj;
   GLuint indBufObj;
   GLuint textureID;
   int tex_id;
};

#endif
