uniform vec3 lightPos;
uniform vec3 ka;
uniform vec3 kd;
uniform vec3 ks;
uniform float s;
varying vec4 vertPosCam;
varying vec3 vertNorCam;

void main()
{
   vec3 fragPos = vec3(vertPosCam.x, vertPosCam.y, vertPosCam.z);
   vec3 cam = vec3(0.0, 0.0, 0.0);

   vec3 n = normalize(vertNorCam);
   vec3 l = normalize(lightPos - fragPos);
   vec3 e = normalize(cam - fragPos);
   vec3 h = normalize(l + e);

   vec3 ca = ka;
   vec3 cd = kd * max(0.0, dot(l, n));
   vec3 cs = ks * pow(max(dot(h, n), 0.0), s);
   vec3 color = ca + cd + cs;

   float intensity = dot(l, n);

   if (intensity > 0.95) {
      gl_FragColor = vec4(1.0 * color, 1.0);
   }
   else if (intensity > 0.5) {
      gl_FragColor = vec4(0.7 * color, 1.0);
   }
   else if (intensity > 0.05) {
      gl_FragColor = vec4(0.35 * color, 1.0);
   }
   else {
      gl_FragColor = vec4(0.1 * color, 1.0);
   }
}
